# Reference

<!-- DO NOT EDIT: This document was generated by Puppet Strings -->

## Table of Contents

### Resource types

* [`dsc_xvhd`](#dsc_xvhd): The DSC xVHD resource type. Automatically generated from version 3.11.0.0
* [`dsc_xvhdfile`](#dsc_xvhdfile): The DSC xVhdFile resource type. Automatically generated from version 3.11.0.0
* [`dsc_xvmdvddrive`](#dsc_xvmdvddrive): The DSC xVMDvdDrive resource type. Automatically generated from version 3.11.0.0
* [`dsc_xvmharddiskdrive`](#dsc_xvmharddiskdrive): The DSC xVMHardDiskDrive resource type. Automatically generated from version 3.11.0.0
* [`dsc_xvmhost`](#dsc_xvmhost): The DSC xVMHost resource type. Automatically generated from version 3.11.0.0
* [`dsc_xvmhyperv`](#dsc_xvmhyperv): The DSC xVMHyperV resource type. Automatically generated from version 3.11.0.0
* [`dsc_xvmnetworkadapter`](#dsc_xvmnetworkadapter): The DSC xVMNetworkAdapter resource type. Automatically generated from version 3.11.0.0
* [`dsc_xvmprocessor`](#dsc_xvmprocessor): The DSC xVMProcessor resource type. Automatically generated from version 3.11.0.0
* [`dsc_xvmscsicontroller`](#dsc_xvmscsicontroller): The DSC xVMScsiController resource type. Automatically generated from version 3.11.0.0
* [`dsc_xvmswitch`](#dsc_xvmswitch): The DSC xVMSwitch resource type. Automatically generated from version 3.11.0.0

## Resource types

### `dsc_xvhd`

The DSC xVHD resource type.
Automatically generated from version 3.11.0.0

#### Properties

The following properties are available in the `dsc_xvhd` type.

##### `dsc_ensure`

Data type: `Optional[Enum['Present', 'Absent']]`

Should the VHD be created or deleted

##### `dsc_filesizebytes`

Data type: `Optional[Integer[0, 18446744073709551615]]`

Current size of the VHD

##### `dsc_generation`

Data type: `Optional[Enum['Vhd', 'Vhdx']]`

Virtual disk format - Vhd or Vhdx

##### `dsc_id`

Data type: `Optional[String]`

Virtual Disk Identifier

##### `dsc_isattached`

Data type: `Optional[Boolean]`

Is the VHD attached to a VM or not

##### `dsc_maximumsizebytes`

Data type: `Optional[Integer[0, 18446744073709551615]]`

Maximum size of Vhd to be created

##### `dsc_parentpath`

Data type: `Optional[String]`

Parent VHD file path, for differencing disk

##### `dsc_type`

Data type: `Optional[Enum['Dynamic', 'Fixed', 'Differencing']]`

Type of Vhd - Dynamic, Fixed, Differencing

#### Parameters

The following parameters are available in the `dsc_xvhd` type.

##### `dsc_name`

namevar

Data type: `String`

Name of the VHD File

##### `dsc_path`

namevar

Data type: `String`

Folder where the VHD will be created

##### `dsc_psdscrunascredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

 

##### `name`

namevar

Data type: `String`

Description of the purpose for this resource declaration.

### `dsc_xvhdfile`

The DSC xVhdFile resource type.
Automatically generated from version 3.11.0.0

#### Properties

The following properties are available in the `dsc_xvhdfile` type.

##### `dsc_checksum`

Data type: `Optional[Enum['ModifiedDate', 'SHA-1', 'SHA-256', 'SHA-512']]`

 

##### `dsc_filedirectory`

Data type: `Array[Struct[{
              type => Optional[Enum['File', 'Directory']],
              ensure => Optional[Enum['Present', 'Absent']],
              content => Optional[String],
              destinationpath => String,
              force => Optional[Boolean],
              sourcepath => Optional[String],
              attributes => Optional[Array[Enum['ReadOnly', 'Hidden', 'System', 'Archive']]],
              recurse => Optional[Boolean]
            }]]`

The FileDirectory objects to copy to the VHD

#### Parameters

The following parameters are available in the `dsc_xvhdfile` type.

##### `dsc_psdscrunascredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

 

##### `dsc_vhdpath`

namevar

Data type: `String`

Path to the VHD

##### `name`

namevar

Data type: `String`

Description of the purpose for this resource declaration.

### `dsc_xvmdvddrive`

The DSC xVMDvdDrive resource type.
Automatically generated from version 3.11.0.0

#### Properties

The following properties are available in the `dsc_xvmdvddrive` type.

##### `dsc_ensure`

Data type: `Optional[Enum['Present', 'Absent']]`

Specifies if the DVD Drive should exist or not.

##### `dsc_path`

Data type: `Optional[String]`

Specifies the full path to the virtual hard disk file or physical hard disk volume for the added DVD drive.

#### Parameters

The following parameters are available in the `dsc_xvmdvddrive` type.

##### `dsc_controllerlocation`

namevar

Data type: `Integer[0, 4294967295]`

Specifies the number of the location on the controller at which the DVD drive is to be added.

##### `dsc_controllernumber`

namevar

Data type: `Integer[0, 4294967295]`

Specifies the number of the controller to which the DVD drive is to be added.

##### `dsc_psdscrunascredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

 

##### `dsc_vmname`

namevar

Data type: `String`

Specifies the name of the virtual machine to which the DVD drive is to be added.

##### `name`

namevar

Data type: `String`

Description of the purpose for this resource declaration.

### `dsc_xvmharddiskdrive`

The DSC xVMHardDiskDrive resource type.
Automatically generated from version 3.11.0.0

#### Properties

The following properties are available in the `dsc_xvmharddiskdrive` type.

##### `dsc_controllerlocation`

Data type: `Optional[Integer[0, 4294967295]]`

Specifies the number of the location on the controller where the disk is attached. If not specified, it defaults to 0.

##### `dsc_controllernumber`

Data type: `Optional[Enum['0', '1', '2', '3']]`

Specifies the number of the controller where the disk is attached. If not specified, it defaults to 0.

##### `dsc_controllertype`

Data type: `Optional[Enum['IDE', 'SCSI']]`

Specifies the controller type - IDE/SCSI where the disk is attached. If not specified, it defaults to SCSI.

##### `dsc_ensure`

Data type: `Optional[Enum['Present', 'Absent']]`

Specifies if the hard disk drive must be present or absent. If not specified, it defaults to Present.

#### Parameters

The following parameters are available in the `dsc_xvmharddiskdrive` type.

##### `dsc_path`

namevar

Data type: `String`

Specifies the full path to the location of the VHD that represents the hard disk drive.

##### `dsc_psdscrunascredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

 

##### `dsc_vmname`

namevar

Data type: `String`

Specifies the name of the virtual machine whose hard disk drive is to be manipulated.

##### `name`

namevar

Data type: `String`

Description of the purpose for this resource declaration.

### `dsc_xvmhost`

The DSC xVMHost resource type.
Automatically generated from version 3.11.0.0

#### Properties

The following properties are available in the `dsc_xvmhost` type.

##### `dsc_enableenhancedsessionmode`

Data type: `Optional[Boolean]`

Indicates whether users can use enhanced mode when they connect to virtual machines on this server by using Virtual Machine Connection.

##### `dsc_fibrechannelwwnn`

Data type: `Optional[String]`

Specifies the default value of the World Wide Node Name on the Hyper-V host.

##### `dsc_fibrechannelwwpnmaximum`

Data type: `Optional[String]`

Specifies the maximum value that can be used to generate World Wide Port Names on the Hyper-V host.

##### `dsc_fibrechannelwwpnminimum`

Data type: `Optional[String]`

Specifies the minimum value that can be used to generate the World Wide Port Names on the Hyper-V host.

##### `dsc_macaddressmaximum`

Data type: `Optional[String]`

Specifies the maximum MAC address using a valid hexadecimal value.

##### `dsc_macaddressminimum`

Data type: `Optional[String]`

Specifies the minimum MAC address using a valid hexadecimal value.

##### `dsc_maximumstoragemigrations`

Data type: `Optional[Integer[0, 4294967295]]`

Specifies the maximum number of storage migrations that can be performed at the same time on the Hyper-V host.

##### `dsc_maximumvirtualmachinemigrations`

Data type: `Optional[Integer[0, 4294967295]]`

Specifies the maximum number of live migrations that can be performed at the same time on the Hyper-V host.

##### `dsc_numaspanningenabled`

Data type: `Optional[Boolean]`

Specifies whether virtual machines on the Hyper-V host can use resources from more than one NUMA node.

##### `dsc_resourcemeteringsaveintervalminute`

Data type: `Optional[Integer[0, 4294967295]]`

Specifies how often the Hyper-V host saves the data that tracks resource usage. The range is a minimum of 60 minutes to a maximum of 1440 (24 hours).

##### `dsc_useanynetworkformigration`

Data type: `Optional[Boolean]`

Specifies how networks are selected for incoming live migration traffic.

##### `dsc_virtualharddiskpath`

Data type: `Optional[String]`

Specifies the default folder to store virtual hard disks on the Hyper-V host.

##### `dsc_virtualmachinemigrationauthenticationtype`

Data type: `Optional[Enum['CredSSP', 'Kerberos']]`

Specifies the type of authentication to be used for live migrations. The acceptable values for this parameter are 'Kerberos' and 'CredSSP'.

##### `dsc_virtualmachinemigrationperformanceoption`

Data type: `Optional[Enum['TCPIP', 'Compression', 'SMB']]`

Specifies the performance option to use for live migration. The acceptable values for this parameter are 'TCPIP', 'Compression' and 'SMB'.

##### `dsc_virtualmachinepath`

Data type: `Optional[String]`

Specifies the default folder to store virtual machine configuration files on the Hyper-V host.

#### Parameters

The following parameters are available in the `dsc_xvmhost` type.

##### `dsc_issingleinstance`

namevar

Data type: `Enum['Yes']`

Specifies the resource is a single instance, the value must be 'Yes'.

##### `dsc_psdscrunascredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

 

##### `name`

namevar

Data type: `String`

Description of the purpose for this resource declaration.

### `dsc_xvmhyperv`

The DSC xVMHyperV resource type.
Automatically generated from version 3.11.0.0

#### Properties

The following properties are available in the `dsc_xvmhyperv` type.

##### `dsc_automaticcheckpointsenabled`

Data type: `Optional[Boolean]`

Enable AutomaticCheckpoints for the VM.

##### `dsc_cpuusage`

Data type: `Optional[Integer[0, 4294967295]]`

CPU Usage of the VM

##### `dsc_creationtime`

Data type: `Optional[Timestamp]`

Creation time of the VM

##### `dsc_enableguestservice`

Data type: `Optional[Boolean]`

Enable Guest Service Interface for the VM.

##### `dsc_ensure`

Data type: `Optional[Enum['Present', 'Absent']]`

Should the VM be created or deleted

##### `dsc_generation`

Data type: `Optional[Integer[0, 4294967295]]`

Virtual machine generation

##### `dsc_hasdynamicmemory`

Data type: `Optional[Boolean]`

Does VM has dynamic memory enabled

##### `dsc_id`

Data type: `Optional[String]`

VM unique ID

##### `dsc_macaddress`

Data type: `Optional[Array[String]]`

MAC address(es) of the VM NICs.

##### `dsc_maximummemory`

Data type: `Optional[Integer[0, 18446744073709551615]]`

Maximum RAM for the VM. This enable dynamic memory.

##### `dsc_memoryassigned`

Data type: `Optional[Integer[0, 18446744073709551615]]`

Memory assigned to the VM

##### `dsc_minimummemory`

Data type: `Optional[Integer[0, 18446744073709551615]]`

Minimum RAM for the VM. This enables dynamic memory.

##### `dsc_networkadapters`

Data type: `Optional[Array[String]]`

Network adapters' IP addresses of the VM

##### `dsc_notes`

Data type: `Optional[String]`

Notes about the VM.

##### `dsc_path`

Data type: `Optional[String]`

Folder where the VM data will be stored

##### `dsc_processorcount`

Data type: `Optional[Integer[0, 4294967295]]`

Processor count for the VM

##### `dsc_restartifneeded`

Data type: `Optional[Boolean]`

If specified, shutdowns and restarts the VM as needed for property changes

##### `dsc_secureboot`

Data type: `Optional[Boolean]`

Enable secure boot for Generation 2 VMs.

##### `dsc_startupmemory`

Data type: `Optional[Integer[0, 18446744073709551615]]`

Startup RAM for the VM.

##### `dsc_state`

Data type: `Optional[Enum['Running', 'Paused', 'Off']]`

State of the VM.

##### `dsc_status`

Data type: `Optional[String]`

Status of the VM

##### `dsc_switchname`

Data type: `Optional[Array[String]]`

Virtual switch(es) associated with the VM

##### `dsc_uptime`

Data type: `Optional[String]`

Uptime of the VM

##### `dsc_vhdpath`

Data type: `String`

VHD associated with the VM

##### `dsc_waitforip`

Data type: `Optional[Boolean]`

Waits for VM to get valid IP address.

#### Parameters

The following parameters are available in the `dsc_xvmhyperv` type.

##### `dsc_name`

namevar

Data type: `String`

Name of the VM

##### `dsc_psdscrunascredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

 

##### `name`

namevar

Data type: `String`

Description of the purpose for this resource declaration.

### `dsc_xvmnetworkadapter`

The DSC xVMNetworkAdapter resource type.
Automatically generated from version 3.11.0.0

#### Properties

The following properties are available in the `dsc_xvmnetworkadapter` type.

##### `dsc_dynamicmacaddress`

Data type: `Optional[Boolean]`

 

##### `dsc_ensure`

Data type: `Optional[Enum['Present', 'Absent']]`

 

##### `dsc_macaddress`

Data type: `Optional[String]`

 

##### `dsc_name`

Data type: `String`

 

##### `dsc_switchname`

Data type: `String`

 

##### `dsc_vmname`

Data type: `String`

 

#### Parameters

The following parameters are available in the `dsc_xvmnetworkadapter` type.

##### `dsc_id`

namevar

Data type: `String`

 

##### `dsc_psdscrunascredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

 

##### `name`

namevar

Data type: `String`

Description of the purpose for this resource declaration.

### `dsc_xvmprocessor`

The DSC xVMProcessor resource type.
Automatically generated from version 3.11.0.0

#### Properties

The following properties are available in the `dsc_xvmprocessor` type.

##### `dsc_compatibilityformigrationenabled`

Data type: `Optional[Boolean]`

Specifies whether the virtual processors features are to be limited for compatibility when migrating the virtual machine to another host.

##### `dsc_compatibilityforolderoperatingsystemsenabled`

Data type: `Optional[Boolean]`

Specifies whether the virtual processorâ??s features are to be limited for compatibility with older operating systems.

##### `dsc_enablehostresourceprotection`

Data type: `Optional[Boolean]`

Specifies whether to enable host resource protection.

##### `dsc_exposevirtualizationextensions`

Data type: `Optional[Boolean]`

Specifies whether nested virtualization is enabled.

##### `dsc_hwthreadcountpercore`

Data type: `Optional[Integer[0, 18446744073709551615]]`

Specifies the maximum thread core per processor core.

##### `dsc_maximum`

Data type: `Optional[Integer[0, 18446744073709551615]]`

Specifies the maximum percentage of resources available to the virtual machine processor to be configured. Allowed values range from 0 to 100.

##### `dsc_maximumcountpernumanode`

Data type: `Optional[Integer[0, 4294967295]]`

Specifies the maximum number of processors per NUMA node to be configured for the virtual machine.

##### `dsc_maximumcountpernumasocket`

Data type: `Optional[Integer[0, 4294967295]]`

Specifies the maximum number of sockets per NUMA node to be configured for the virtual machine.

##### `dsc_relativeweight`

Data type: `Optional[Integer[0, 4294967295]]`

Specifies the priority for allocating the physical computer's processing power to this virtual machine relative to others. Allowed values range from 1 to 10000.

##### `dsc_reserve`

Data type: `Optional[Integer[0, 18446744073709551615]]`

Specifies the percentage of processor resources to be reserved for this virtual machine. Allowed values range from 0 to 100.

##### `dsc_resourcepoolname`

Data type: `Optional[String]`

Specifies the name of the processor resource pool to be used.

##### `dsc_restartifneeded`

Data type: `Optional[Boolean]`

If specified, shutdowns and restarts the VM if needed for property changes.

#### Parameters

The following parameters are available in the `dsc_xvmprocessor` type.

##### `dsc_psdscrunascredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

 

##### `dsc_vmname`

namevar

Data type: `String`

Specifies the name of the virtual machine on which the processor is to be configured.

##### `name`

namevar

Data type: `String`

Description of the purpose for this resource declaration.

### `dsc_xvmscsicontroller`

The DSC xVMScsiController resource type.
Automatically generated from version 3.11.0.0

#### Properties

The following properties are available in the `dsc_xvmscsicontroller` type.

##### `dsc_ensure`

Data type: `Optional[Enum['Present', 'Absent']]`

Specifies if the SCSI controller should exist or not. If not specified, it defaults to Present.

##### `dsc_restartifneeded`

Data type: `Optional[Boolean]`

Specifies if the VM should be restarted if needed for property changes. If not specified, it defaults to False.

#### Parameters

The following parameters are available in the `dsc_xvmscsicontroller` type.

##### `dsc_controllernumber`

namevar

Data type: `Enum['0', '1', '2', '3']`

Specifies the number of the SCSI controller whose status is to be controlled. If not specified, it defaults to 0.

##### `dsc_psdscrunascredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

 

##### `dsc_vmname`

namevar

Data type: `String`

Specifies the name of the virtual machine whose SCSI controller status is to be controlled

##### `name`

namevar

Data type: `String`

Description of the purpose for this resource declaration.

### `dsc_xvmswitch`

The DSC xVMSwitch resource type.
Automatically generated from version 3.11.0.0

#### Properties

The following properties are available in the `dsc_xvmswitch` type.

##### `dsc_allowmanagementos`

Data type: `Optional[Boolean]`

Specify if the VM host has access to the physical NIC

##### `dsc_bandwidthreservationmode`

Data type: `Optional[Enum['Default', 'Weight', 'Absolute', 'None', 'NA']]`

Type of Bandwidth Reservation Mode to use for the switch

##### `dsc_enableembeddedteaming`

Data type: `Optional[Boolean]`

Should embedded NIC teaming be used (Windows Server 2016 only)

##### `dsc_ensure`

Data type: `Optional[Enum['Present', 'Absent']]`

Whether switch should be present or absent

##### `dsc_id`

Data type: `Optional[String]`

Unique ID for the switch

##### `dsc_loadbalancingalgorithm`

Data type: `Optional[Enum['Dynamic', 'HyperVPort']]`

Specifies the load balancing algorithm that this switch team uses

##### `dsc_netadapterinterfacedescription`

Data type: `Optional[String]`

Description of the network interface

##### `dsc_netadaptername`

Data type: `Optional[Array[String]]`

Network adapter name(s) for external switch type

#### Parameters

The following parameters are available in the `dsc_xvmswitch` type.

##### `dsc_name`

namevar

Data type: `String`

Name of the VM Switch

##### `dsc_psdscrunascredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

 

##### `dsc_type`

namevar

Data type: `Enum['External', 'Internal', 'Private']`

Type of switch

##### `name`

namevar

Data type: `String`

Description of the purpose for this resource declaration.

