require 'puppet/resource_api'

Puppet::ResourceApi.register_type(
  name: 'dsc_xvmdvddrive',
  dscmeta_resource_friendly_name: 'xVMDvdDrive',
  dscmeta_resource_name: 'MSFT_xVMDvdDrive',
  dscmeta_module_name: 'xHyper-V',
  dscmeta_module_version: '3.11.0.0',
  docs: 'The DSC xVMDvdDrive resource type.
         Automatically generated from version 3.11.0.0',
  features: ['simple_get_filter', 'canonicalize'],
  attributes: {
    name: {
      type:      'String',
      desc:      'Description of the purpose for this resource declaration.',
      behaviour: :namevar,
    },
    dsc_psdscrunascredential: {
      type: 'Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]',
      desc: ' ',
      behaviour: :parameter,
      mandatory_for_get: false,
      mandatory_for_set: false,
      mof_type: 'PSCredential',
      mof_is_embedded: true,
    },
    dsc_ensure: {
      type: "Optional[Enum['Present', 'Absent']]",
      desc: 'Specifies if the DVD Drive should exist or not.',

      mandatory_for_get: false,
      mandatory_for_set: false,
      mof_type: 'String',
      mof_is_embedded: false,
    },
    dsc_controllerlocation: {
      type: 'Integer[0, 4294967295]',
      desc: 'Specifies the number of the location on the controller at which the DVD drive is to be added.',
      behaviour: :namevar,
      mandatory_for_get: true,
      mandatory_for_set: true,
      mof_type: 'UInt32',
      mof_is_embedded: false,
    },
    dsc_controllernumber: {
      type: 'Integer[0, 4294967295]',
      desc: 'Specifies the number of the controller to which the DVD drive is to be added.',
      behaviour: :namevar,
      mandatory_for_get: true,
      mandatory_for_set: true,
      mof_type: 'UInt32',
      mof_is_embedded: false,
    },
    dsc_vmname: {
      type: 'String',
      desc: 'Specifies the name of the virtual machine to which the DVD drive is to be added.',
      behaviour: :namevar,
      mandatory_for_get: true,
      mandatory_for_set: true,
      mof_type: 'String',
      mof_is_embedded: false,
    },
    dsc_path: {
      type: 'Optional[String]',
      desc: 'Specifies the full path to the virtual hard disk file or physical hard disk volume for the added DVD drive.',

      mandatory_for_get: false,
      mandatory_for_set: false,
      mof_type: 'String',
      mof_is_embedded: false,
    },
  },
)
